Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkMPICommunicator Class Reference

`#include <vtkMPICommunicator.h>`

Inheritance diagram for vtkMPICommunicator:

[legend]
Collaboration diagram for vtkMPICommunicator:

[legend]
List of all members.

## Detailed Description

Class for creating user defined MPI communicators.

Date:
  2002/08/17 19:40:54

Revision:
  1.25

This class can be used to create user defined MPI communicators. The actual creation (with MPI_Comm_create) occurs in Initialize which takes as arguments a super-communicator and a group of process ids. The new communicator is created by including the processes contained in the group. The global communicator (equivalent to MPI_COMM_WORLD) can be obtained using the class method GetWorldCommunicator. It is important to note that this communicator should not be used on the processes not contained in the group. For example, if the group contains processes 0 and 1, controller->SetCommunicator(communicator) would cause an MPI error on any other process.

See also:
  vtkMPIController vtkMPIGroup

Created by:
  - Geveci, Berk

CVS contributions (if > 5%):
  - Geveci, Berk (71%)
  - Lee, Jeff (22%)

CVS logs (CVSweb):
  - .`h` (`/Parallel/vtkMPICommunicator.h)`
  - .`cxx` (`/Parallel/vtkMPICommunicator.cxx)`

Tests:
  vtkMPICommunicator (Tests)

Definition at line 64 of file vtkMPICommunicator.h.

## Public Types
typedef vtkCommunicator | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
virtual void | PrintSelf (ostream &os, vtkIndent indent)
int | Initialize (vtkMPICommunicator *mpiComm, vtkMPIGroup *group)
int | ReduceMin (int *data, int *to, int size, int root)
int | ReduceMin (long *data, long *to, int size, int root)
int | ReduceMin (float *data, float *to, int size, int root)
int | ReduceMin (double *data, double *to, int size, int root)
int | ReduceSum (int *data, int *to, int size, int root)
int | ReduceSum (long *data, long *to, int size, int root)
int | ReduceSum (float *data, float *to, int size, int root)
int | ReduceSum (double *data, double *to, int size, int root)
int | ReduceAnd (bool *data, bool *to, int size, int root)
int | ReduceOr (bool *data, bool *to, int size, int root)
vtkMPICommunicatorOpaqueComm * | GetMPIComm ()
virtual int | Send (int *data, int length, int remoteProcessId, int tag)
virtual int | Send (unsigned long *data, int length, int remoteProcessId, int tag)
virtual int | Send (char *data, int length, int remoteProcessId, int tag)
virtual int | Send (unsigned char *data, int length, int remoteProcessId, int tag)
virtual int | Send (float *data, int length, int remoteProcessId, int tag)
virtual int | Send (double *data, int length, int remoteProcessId, int tag)
virtual int | Send (vtkDataObject *data, int remoteProcessId, int tag)
virtual int | Send (vtkDataArray *data, int remoteProcessId, int tag)
int | NoBlockSend (int *data, int length, int remoteProcessId, int tag, Request &req)
int | NoBlockSend (unsigned long *data, int length, int remoteProcessId, int tag, Request &req)
int | NoBlockSend (char *data, int length, int remoteProcessId, int tag, Request &req)
int | NoBlockSend (float *data, int length, int remoteProcessId, int tag, Request &req)
virtual int | Receive (int *data, int length, int remoteProcessId, int tag)
virtual int | Receive (unsigned long *data, int length, int remoteProcessId, int tag)
virtual int | Receive (char *data, int length, int remoteProcessId, int tag)
virtual int | Receive (unsigned char *data, int length, int remoteProcessId, int tag)
virtual int | Receive (float *data, int length, int remoteProcessId, int tag)
virtual int | Receive (double *data, int length, int remoteProcessId, int tag)
virtual int | Receive (vtkDataObject *data, int remoteProcessId, int tag)
virtual int | Receive (vtkDataArray *data, int remoteProcessId, int tag)
int | NoBlockReceive (int *data, int length, int remoteProcessId, int tag, Request &req)
int | NoBlockReceive (unsigned long *data, int length, int remoteProcessId, int tag, Request &req)
int | NoBlockReceive (char *data, int length, int remoteProcessId, int tag, Request &req)
int | NoBlockReceive (float *data, int length, int remoteProcessId, int tag, Request &req)
int | Broadcast (int *data, int length, int root)
int | Broadcast (unsigned long *data, int length, int root)
int | Broadcast (char *data, int length, int root)
int | Broadcast (float *data, int length, int root)
int | Broadcast (double *data, int length, int root)
int | Gather (int *data, int *to, int length, int root)
int | Gather (unsigned long *data, unsigned long *to, int length, int root)
int | Gather (char *data, char *to, int length, int root)
int | Gather (float *data, float *to, int length, int root)
int | Gather (double *data, double *to, int length, int root)
int | GatherV (int *data, int *to, int sendlength, int *recvlengths, int *offsets, int root)
int | GatherV (unsigned long *data, unsigned long *to, int sendlength, int *recvlengths, int *offsets, int root)
int | GatherV (char *data, char *to, int sendlength, int *recvlengths, int *offsets, int root)
int | GatherV (float *data, float *to, int sendlength, int *recvlengths, int *offsets, int root)
int | GatherV (double *data, double *to, int sendlength, int *recvlengths, int *offsets, int root)
int | ReduceMax (int *data, int *to, int size, int root)
int | ReduceMax (long *data, long *to, int size, int root)
int | ReduceMax (float *data, float *to, int size, int root)
int | ReduceMax (double *data, double *to, int size, int root)
## Static Public Methods
int | IsTypeOf (const char *type)
vtkMPICommunicator * | SafeDownCast (vtkObject *o)
vtkMPICommunicator * | New ()
vtkMPICommunicator * | GetWorldCommunicator ()
char * | Allocate (size_t size)
void | Free (char *ptr)
## Protected Methods
| vtkMPICommunicator ()
| ~vtkMPICommunicator ()
virtual void | SetGroup (vtkMPIGroup *)
void | InitializeCopy (vtkMPICommunicator *source)
void | CopyFrom (vtkMPICommunicator *source)
void | Duplicate (vtkMPICommunicator *source)
virtual void | SetKeepHandle (int)
virtual void | KeepHandleOn ()
virtual void | KeepHandleOff ()
## Static Protected Methods
int | CheckForMPIError (int err)
## Protected Attributes
vtkMPICommunicatorOpaqueComm * | Comm
vtkMPIGroup * | Group
int | Initialized
int | KeepHandle
## Static Protected Attributes
vtkMPICommunicator * | WorldCommunicator
## Friends
class | vtkMPIController

## Member Typedef Documentation

typedef vtkCommunicator vtkMPICommunicator::Superclass

| Reimplemented from vtkCommunicator. Definition at line 67 of file vtkMPICommunicator.h.

## Constructor & Destructor Documentation

vtkMPICommunicator::vtkMPICommunicator | ( |  | ) | `[protected]`

vtkMPICommunicator::~vtkMPICommunicator | ( |  | ) | `[protected]`

## Member Function Documentation

virtual const char* vtkMPICommunicator::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkCommunicator.

int vtkMPICommunicator::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkCommunicator.

virtual int vtkMPICommunicator::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkCommunicator.

vtkMPICommunicator* vtkMPICommunicator::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkCommunicator.

vtkMPICommunicator* vtkMPICommunicator::New | ( |  | ) | `[static]`

| Creates an empty communicator. Reimplemented from vtkObject.

vtkMPICommunicator* vtkMPICommunicator::GetWorldCommunicator | ( |  | ) | `[static]`

| Returns the singleton which behaves as the global communicator (MPI_COMM_WORLD)

virtual void vtkMPICommunicator::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkCommunicator.

int vtkMPICommunicator::Initialize | ( | vtkMPICommunicator * | mpiComm,
|  | vtkMPIGroup * | group
| ) |

| Used to initialize (i.e. create the underlying MPI_Comm) the communicator. Note that group is also stored in an instance variable (the reference count of group is increased by 1). group->Delete() can be safely invoked after this.

virtual int vtkMPICommunicator::Send | ( | int * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag
| ) | `[virtual]`

| This method sends data to another process. Tag eliminates ambiguity when multiple sends or receives exist in the same process. Implements vtkCommunicator.

virtual int vtkMPICommunicator::Send | ( | unsigned long * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag
| ) | `[virtual]`

| This method sends data to another process. Tag eliminates ambiguity when multiple sends or receives exist in the same process. Implements vtkCommunicator.

virtual int vtkMPICommunicator::Send | ( | char * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag
| ) | `[virtual]`

| This method sends data to another process. Tag eliminates ambiguity when multiple sends or receives exist in the same process. Implements vtkCommunicator.

virtual int vtkMPICommunicator::Send | ( | unsigned char * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag
| ) | `[virtual]`

| This method sends data to another process. Tag eliminates ambiguity when multiple sends or receives exist in the same process. Implements vtkCommunicator.

virtual int vtkMPICommunicator::Send | ( | float * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag
| ) | `[virtual]`

| This method sends data to another process. Tag eliminates ambiguity when multiple sends or receives exist in the same process. Implements vtkCommunicator.

virtual int vtkMPICommunicator::Send | ( | double * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag
| ) | `[virtual]`

| This method sends data to another process. Tag eliminates ambiguity when multiple sends or receives exist in the same process. Implements vtkCommunicator.

virtual int vtkMPICommunicator::Send | ( | vtkDataObject * | data,
|  | int | remoteProcessId,
|  | int | tag
| ) | `[inline, virtual]`

| This method sends data to another process. Tag eliminates ambiguity when multiple sends or receives exist in the same process. Reimplemented from vtkCommunicator. Definition at line 102 of file vtkMPICommunicator.h. References vtkCommunicator::Send().

virtual int vtkMPICommunicator::Send | ( | vtkDataArray * | data,
|  | int | remoteProcessId,
|  | int | tag
| ) | `[inline, virtual]`

| This method sends data to another process. Tag eliminates ambiguity when multiple sends or receives exist in the same process. Reimplemented from vtkCommunicator. Definition at line 104 of file vtkMPICommunicator.h. References vtkCommunicator::Send().

int vtkMPICommunicator::NoBlockSend | ( | int * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag,
|  | Request & | req
| ) |

| This method sends data to another process (non-blocking). Tag eliminates ambiguity when multiple sends or receives exist in the same process. The last argument, vtkMPICommunicator::Request& req can later be used (with req.Test() ) to test the success of the message.

int vtkMPICommunicator::NoBlockSend | ( | unsigned long * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag,
|  | Request & | req
| ) |

| This method sends data to another process (non-blocking). Tag eliminates ambiguity when multiple sends or receives exist in the same process. The last argument, vtkMPICommunicator::Request& req can later be used (with req.Test() ) to test the success of the message.

int vtkMPICommunicator::NoBlockSend | ( | char * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag,
|  | Request & | req
| ) |

| This method sends data to another process (non-blocking). Tag eliminates ambiguity when multiple sends or receives exist in the same process. The last argument, vtkMPICommunicator::Request& req can later be used (with req.Test() ) to test the success of the message.

int vtkMPICommunicator::NoBlockSend | ( | float * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag,
|  | Request & | req
| ) |

| This method sends data to another process (non-blocking). Tag eliminates ambiguity when multiple sends or receives exist in the same process. The last argument, vtkMPICommunicator::Request& req can later be used (with req.Test() ) to test the success of the message.

virtual int vtkMPICommunicator::Receive | ( | int * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag
| ) | `[virtual]`

| This method receives data from a corresponding send. It blocks until the receive is finished. Implements vtkCommunicator.

virtual int vtkMPICommunicator::Receive | ( | unsigned long * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag
| ) | `[virtual]`

| This method receives data from a corresponding send. It blocks until the receive is finished. Implements vtkCommunicator.

virtual int vtkMPICommunicator::Receive | ( | char * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag
| ) | `[virtual]`

| This method receives data from a corresponding send. It blocks until the receive is finished. Implements vtkCommunicator.

virtual int vtkMPICommunicator::Receive | ( | unsigned char * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag
| ) | `[virtual]`

| This method receives data from a corresponding send. It blocks until the receive is finished. Implements vtkCommunicator.

virtual int vtkMPICommunicator::Receive | ( | float * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag
| ) | `[virtual]`

| This method receives data from a corresponding send. It blocks until the receive is finished. Implements vtkCommunicator.

virtual int vtkMPICommunicator::Receive | ( | double * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag
| ) | `[virtual]`

| This method receives data from a corresponding send. It blocks until the receive is finished. Implements vtkCommunicator.

virtual int vtkMPICommunicator::Receive | ( | vtkDataObject * | data,
|  | int | remoteProcessId,
|  | int | tag
| ) | `[inline, virtual]`

| This method receives data from a corresponding send. It blocks until the receive is finished. Reimplemented from vtkCommunicator. Definition at line 157 of file vtkMPICommunicator.h. References vtkCommunicator::Receive().

virtual int vtkMPICommunicator::Receive | ( | vtkDataArray * | data,
|  | int | remoteProcessId,
|  | int | tag
| ) | `[inline, virtual]`

| This method receives data from a corresponding send. It blocks until the receive is finished. Reimplemented from vtkCommunicator. Definition at line 159 of file vtkMPICommunicator.h. References vtkCommunicator::Receive().

int vtkMPICommunicator::NoBlockReceive | ( | int * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag,
|  | Request & | req
| ) |

| This method receives data from a corresponding send (non-blocking). The last argument, vtkMPICommunicator::Request& req can later be used (with req.Test() ) to test the success of the message.

int vtkMPICommunicator::NoBlockReceive | ( | unsigned long * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag,
|  | Request & | req
| ) |

| This method receives data from a corresponding send (non-blocking). The last argument, vtkMPICommunicator::Request& req can later be used (with req.Test() ) to test the success of the message.

int vtkMPICommunicator::NoBlockReceive | ( | char * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag,
|  | Request & | req
| ) |

| This method receives data from a corresponding send (non-blocking). The last argument, vtkMPICommunicator::Request& req can later be used (with req.Test() ) to test the success of the message.

int vtkMPICommunicator::NoBlockReceive | ( | float * | data,
|  | int | length,
|  | int | remoteProcessId,
|  | int | tag,
|  | Request & | req
| ) |

| This method receives data from a corresponding send (non-blocking). The last argument, vtkMPICommunicator::Request& req can later be used (with req.Test() ) to test the success of the message.

int vtkMPICommunicator::Broadcast | ( | int * | data,
|  | int | length,
|  | int | root
| ) |

| Broadcast an array from the given root process.

int vtkMPICommunicator::Broadcast | ( | unsigned long * | data,
|  | int | length,
|  | int | root
| ) |

| Broadcast an array from the given root process.

int vtkMPICommunicator::Broadcast | ( | char * | data,
|  | int | length,
|  | int | root
| ) |

| Broadcast an array from the given root process.

int vtkMPICommunicator::Broadcast | ( | float * | data,
|  | int | length,
|  | int | root
| ) |

| Broadcast an array from the given root process.

int vtkMPICommunicator::Broadcast | ( | double * | data,
|  | int | length,
|  | int | root
| ) |

| Broadcast an array from the given root process.

int vtkMPICommunicator::Gather | ( | int * | data,
|  | int * | to,
|  | int | length,
|  | int | root
| ) |

| Gather an array to the given root process (the "to" pointer must point to an array of length length*numProcesses

int vtkMPICommunicator::Gather | ( | unsigned long * | data,
|  | unsigned long * | to,
|  | int | length,
|  | int | root
| ) |

| Gather an array to the given root process (the "to" pointer must point to an array of length length*numProcesses

int vtkMPICommunicator::Gather | ( | char * | data,
|  | char * | to,
|  | int | length,
|  | int | root
| ) |

| Gather an array to the given root process (the "to" pointer must point to an array of length length*numProcesses

int vtkMPICommunicator::Gather | ( | float * | data,
|  | float * | to,
|  | int | length,
|  | int | root
| ) |

| Gather an array to the given root process (the "to" pointer must point to an array of length length*numProcesses

int vtkMPICommunicator::Gather | ( | double * | data,
|  | double * | to,
|  | int | length,
|  | int | root
| ) |

| Gather an array to the given root process (the "to" pointer must point to an array of length length*numProcesses

int vtkMPICommunicator::GatherV | ( | int * | data,
|  | int * | to,
|  | int | sendlength,
|  | int * | recvlengths,
|  | int * | offsets,
|  | int | root
| ) |

| Gather an array to the given root process. This method allows for arrays of different sizes on all processes to be gathered into a single array on the root process. For the root process, all arguments are significant, on non-root processes, only data, sendlength, and root are significant (all other args can be NULL). The argument offsets is an array of integers describing offset for each sent array.

int vtkMPICommunicator::GatherV | ( | unsigned long * | data,
|  | unsigned long * | to,
|  | int | sendlength,
|  | int * | recvlengths,
|  | int * | offsets,
|  | int | root
| ) |

| Gather an array to the given root process. This method allows for arrays of different sizes on all processes to be gathered into a single array on the root process. For the root process, all arguments are significant, on non-root processes, only data, sendlength, and root are significant (all other args can be NULL). The argument offsets is an array of integers describing offset for each sent array.

int vtkMPICommunicator::GatherV | ( | char * | data,
|  | char * | to,
|  | int | sendlength,
|  | int * | recvlengths,
|  | int * | offsets,
|  | int | root
| ) |

| Gather an array to the given root process. This method allows for arrays of different sizes on all processes to be gathered into a single array on the root process. For the root process, all arguments are significant, on non-root processes, only data, sendlength, and root are significant (all other args can be NULL). The argument offsets is an array of integers describing offset for each sent array.

int vtkMPICommunicator::GatherV | ( | float * | data,
|  | float * | to,
|  | int | sendlength,
|  | int * | recvlengths,
|  | int * | offsets,
|  | int | root
| ) |

| Gather an array to the given root process. This method allows for arrays of different sizes on all processes to be gathered into a single array on the root process. For the root process, all arguments are significant, on non-root processes, only data, sendlength, and root are significant (all other args can be NULL). The argument offsets is an array of integers describing offset for each sent array.

int vtkMPICommunicator::GatherV | ( | double * | data,
|  | double * | to,
|  | int | sendlength,
|  | int * | recvlengths,
|  | int * | offsets,
|  | int | root
| ) |

| Gather an array to the given root process. This method allows for arrays of different sizes on all processes to be gathered into a single array on the root process. For the root process, all arguments are significant, on non-root processes, only data, sendlength, and root are significant (all other args can be NULL). The argument offsets is an array of integers describing offset for each sent array.

int vtkMPICommunicator::ReduceMax | ( | int * | data,
|  | int * | to,
|  | int | size,
|  | int | root
| ) |

| Reduce an array to the given root process.

int vtkMPICommunicator::ReduceMax | ( | long * | data,
|  | long * | to,
|  | int | size,
|  | int | root
| ) |

| Reduce an array to the given root process.

int vtkMPICommunicator::ReduceMax | ( | float * | data,
|  | float * | to,
|  | int | size,
|  | int | root
| ) |

| Reduce an array to the given root process.

int vtkMPICommunicator::ReduceMax | ( | double * | data,
|  | double * | to,
|  | int | size,
|  | int | root
| ) |

| Reduce an array to the given root process.

int vtkMPICommunicator::ReduceMin | ( | int * | data,
|  | int * | to,
|  | int | size,
|  | int | root
| ) |

int vtkMPICommunicator::ReduceMin | ( | long * | data,
|  | long * | to,
|  | int | size,
|  | int | root
| ) |

int vtkMPICommunicator::ReduceMin | ( | float * | data,
|  | float * | to,
|  | int | size,
|  | int | root
| ) |

int vtkMPICommunicator::ReduceMin | ( | double * | data,
|  | double * | to,
|  | int | size,
|  | int | root
| ) |

int vtkMPICommunicator::ReduceSum | ( | int * | data,
|  | int * | to,
|  | int | size,
|  | int | root
| ) |

int vtkMPICommunicator::ReduceSum | ( | long * | data,
|  | long * | to,
|  | int | size,
|  | int | root
| ) |

int vtkMPICommunicator::ReduceSum | ( | float * | data,
|  | float * | to,
|  | int | size,
|  | int | root
| ) |

int vtkMPICommunicator::ReduceSum | ( | double * | data,
|  | double * | to,
|  | int | size,
|  | int | root
| ) |

int vtkMPICommunicator::ReduceAnd | ( | bool * | data,
|  | bool * | to,
|  | int | size,
|  | int | root
| ) |

int vtkMPICommunicator::ReduceOr | ( | bool * | data,
|  | bool * | to,
|  | int | size,
|  | int | root
| ) |

vtkMPICommunicatorOpaqueComm* vtkMPICommunicator::GetMPIComm | ( |  | ) | `[inline]`

| Definition at line 243 of file vtkMPICommunicator.h.

char* vtkMPICommunicator::Allocate | ( | size_t | size | ) | `[static]`

void vtkMPICommunicator::Free | ( | char * | ptr | ) | `[static]`

virtual void vtkMPICommunicator::SetGroup | ( | vtkMPIGroup * |  | ) | `[protected, virtual]`

virtual void vtkMPICommunicator::SetKeepHandle | ( | int |  | ) | `[protected, virtual]`

| KeepHandle is normally off. This means that the MPI communicator handle will be freed at the destruction of the object. However, if the handle was copied from another object (via CopyFrom() not Duplicate()), this has to be turned on otherwise the handle will be freed multiple times causing MPI failure. The alternative to this is using reference counting but it is unnecessarily complicated for this case.

virtual void vtkMPICommunicator::KeepHandleOn | ( |  | ) | `[protected, virtual]`

| KeepHandle is normally off. This means that the MPI communicator handle will be freed at the destruction of the object. However, if the handle was copied from another object (via CopyFrom() not Duplicate()), this has to be turned on otherwise the handle will be freed multiple times causing MPI failure. The alternative to this is using reference counting but it is unnecessarily complicated for this case.

virtual void vtkMPICommunicator::KeepHandleOff | ( |  | ) | `[protected, virtual]`

| KeepHandle is normally off. This means that the MPI communicator handle will be freed at the destruction of the object. However, if the handle was copied from another object (via CopyFrom() not Duplicate()), this has to be turned on otherwise the handle will be freed multiple times causing MPI failure. The alternative to this is using reference counting but it is unnecessarily complicated for this case.

void vtkMPICommunicator::InitializeCopy | ( | vtkMPICommunicator * | source | ) | `[protected]`

void vtkMPICommunicator::CopyFrom | ( | vtkMPICommunicator * | source | ) | `[protected]`

| Copies all the attributes of source, deleting previously stored data. The MPI communicator handle is also copied. Normally, this should not be needed. It is used during the construction of a new communicator for copying the world communicator, keeping the same context.

void vtkMPICommunicator::Duplicate | ( | vtkMPICommunicator * | source | ) | `[protected]`

| Copies all the attributes of source, deleting previously stored data EXCEPT the MPI communicator handle which is duplicated with MPI_Comm_dup(). Therefore, although the processes in the communicator remain the same, a new context is created. This prevents the two communicators from intefering with each other during message send/receives even if the tags are the same.

int vtkMPICommunicator::CheckForMPIError | ( | int | err | ) | `[static, protected]`

## Friends And Related Function Documentation

friend class vtkMPIController`[friend]`

| Definition at line 241 of file vtkMPICommunicator.h.

## Member Data Documentation

vtkMPICommunicator* vtkMPICommunicator::WorldCommunicator`[static, protected]`

| Definition at line 273 of file vtkMPICommunicator.h.

vtkMPICommunicatorOpaqueComm* vtkMPICommunicator::Comm`[protected]`

| Definition at line 291 of file vtkMPICommunicator.h.

vtkMPIGroup* vtkMPICommunicator::Group`[protected]`

| Definition at line 292 of file vtkMPICommunicator.h.

int vtkMPICommunicator::Initialized`[protected]`

| Definition at line 294 of file vtkMPICommunicator.h.

int vtkMPICommunicator::KeepHandle`[protected]`

| Definition at line 295 of file vtkMPICommunicator.h.

The documentation for this class was generated from the following file:

- Parallel/vtkMPICommunicator.h